using System;
using System.Collections.Generic;
using System.ComponentModel;
using Microsoft.Ccr.Core;
using Microsoft.Dss.Core.Attributes;
using Microsoft.Dss.ServiceModel.Dssp;
using Microsoft.Dss.ServiceModel.DsspServiceBase;
using W3C.Soap;
using submgr = Microsoft.Dss.Services.SubscriptionManager;

namespace Robotics.csproj401
{
    [Contract(Contract.Identifier)]
    [DisplayName("csproj401")]
    [Description("csproj401 service (no description provided)")]
    class csproj401Service : DsspServiceBase
    {
        /// <summary>
        /// Service state
        /// </summary>
        [ServiceState]
        csproj401State _state = new csproj401State();

        /// <summary>
        /// Main service port
        /// </summary>
        [ServicePort("/csproj401", AllowMultipleInstances = true)]
        csproj401Operations _mainPort = new csproj401Operations();

        [SubscriptionManagerPartner]
        submgr.SubscriptionManagerPort _submgrPort = new submgr.SubscriptionManagerPort();

        /// <summary>
        /// Service constructor
        /// </summary>
        public csproj401Service(DsspServiceCreationPort creationPort)
            : base(creationPort)
        {
//            _state.Name = "okawa";
//            _state.Male = true;
//            _state.Height = 168.5f;
//            _state.Weight = 60.23f;
        }

        /// <summary>
        /// Service start
        /// </summary>
        protected override void Start()
        {

            // 
            // Add service specific initialization here
            // 

            base.Start();
            LogInfo("Hello World!");
        }

        /// <summary>
        /// Handles Subscribe messages
        /// </summary>
        /// <param name="subscribe">the subscribe request</param>
        [ServiceHandler]
        public void SubscribeHandler(Subscribe subscribe)
        {
            SubscribeHelper(_submgrPort, subscribe.Body, subscribe.ResponsePort);
        }
    }
}


