using System;
using System.Collections.Generic;
using System.ComponentModel;
using Microsoft.Ccr.Core;
using Microsoft.Dss.Core.Attributes;
using Microsoft.Dss.ServiceModel.Dssp;
using Microsoft.Dss.ServiceModel.DsspServiceBase;
using W3C.Soap;

namespace Robotics.csproj401
{
    /// <summary>
    /// csproj401 contract class
    /// </summary>
    public sealed class Contract
    {
        /// <summary>
        /// DSS contract identifer for csproj401
        /// </summary>
        [DataMember]
        public const string Identifier = "http://schemas.tempuri.org/2011/03/csproj401.html";
    }

    /// <summary>
    /// csproj401 state
    /// </summary>
    [DataContract]
    public class csproj401State
    {
//        [DataMember]
//        public string Name { get; set; }
//        [DataMember]
//        public bool Male { get; set; }
//        [DataMember]
//        public float Height { get; set; }
//        [DataMember]
//        public float Weight { get; set; }
    }

    /// <summary>
    /// csproj401 main operations port
    /// </summary>
    [ServicePort]
    public class csproj401Operations : PortSet<DsspDefaultLookup, DsspDefaultDrop, Get, Subscribe>
    {
    }

    /// <summary>
    /// csproj401 get operation
    /// </summary>
    public class Get : Get<GetRequestType, PortSet<csproj401State, Fault>>
    {
        /// <summary>
        /// Creates a new instance of Get
        /// </summary>
        public Get()
        {
        }

        /// <summary>
        /// Creates a new instance of Get
        /// </summary>
        /// <param name="body">the request message body</param>
        public Get(GetRequestType body)
            : base(body)
        {
        }

        /// <summary>
        /// Creates a new instance of Get
        /// </summary>
        /// <param name="body">the request message body</param>
        /// <param name="responsePort">the response port for the request</param>
        public Get(GetRequestType body, PortSet<csproj401State, Fault> responsePort)
            : base(body, responsePort)
        {
        }
    }

    /// <summary>
    /// csproj401 subscribe operation
    /// </summary>
    public class Subscribe : Subscribe<SubscribeRequestType, PortSet<SubscribeResponseType, Fault>>
    {
        /// <summary>
        /// Creates a new instance of Subscribe
        /// </summary>
        public Subscribe()
        {
        }

        /// <summary>
        /// Creates a new instance of Subscribe
        /// </summary>
        /// <param name="body">the request message body</param>
        public Subscribe(SubscribeRequestType body)
            : base(body)
        {
        }

        /// <summary>
        /// Creates a new instance of Subscribe
        /// </summary>
        /// <param name="body">the request message body</param>
        /// <param name="responsePort">the response port for the request</param>
        public Subscribe(SubscribeRequestType body, PortSet<SubscribeResponseType, Fault> responsePort)
            : base(body, responsePort)
        {
        }
    }
}


