using System;
using System.Collections.Generic;
using System.ComponentModel;
using Microsoft.Ccr.Core;
using Microsoft.Dss.Core.Attributes;
using Microsoft.Dss.ServiceModel.Dssp;
using Microsoft.Dss.ServiceModel.DsspServiceBase;
using W3C.Soap;

namespace Robotics.csproj402
{
    /// <summary>
    /// csproj402 contract class
    /// </summary>
    public sealed class Contract
    {
        /// <summary>
        /// DSS contract identifer for csproj402
        /// </summary>
        [DataMember]
        public const string Identifier = "http://schemas.tempuri.org/2011/03/csproj402.html";
    }

    /// <summary>
    /// csproj402 state
    /// </summary>
    [DataContract]
    public class csproj402State
    {
        [DataMember]
        public string Name { get; set; }
        [DataMember]
        public bool Male { get; set; }
        [DataMember]
        public float Height { get; set; }
        [DataMember]
        public float Weight { get; set; }
    }

    /// <summary>
    /// csproj402 main operations port
    /// </summary>
    [ServicePort]
    public class csproj402Operations : PortSet<DsspDefaultLookup, DsspDefaultDrop, Get, Subscribe, Replace>
    {
    }

    /// <summary>
    /// csproj402 get operation
    /// </summary>
    public class Get : Get<GetRequestType, PortSet<csproj402State, Fault>>
    {
        /// <summary>
        /// Creates a new instance of Get
        /// </summary>
        public Get()
        {
        }

        /// <summary>
        /// Creates a new instance of Get
        /// </summary>
        /// <param name="body">the request message body</param>
        public Get(GetRequestType body)
            : base(body)
        {
        }

        /// <summary>
        /// Creates a new instance of Get
        /// </summary>
        /// <param name="body">the request message body</param>
        /// <param name="responsePort">the response port for the request</param>
        public Get(GetRequestType body, PortSet<csproj402State, Fault> responsePort)
            : base(body, responsePort)
        {
        }
    }

    /// <summary>
    /// csproj402 subscribe operation
    /// </summary>
    public class Subscribe : Subscribe<SubscribeRequestType, PortSet<SubscribeResponseType, Fault>>
    {
        /// <summary>
        /// Creates a new instance of Subscribe
        /// </summary>
        public Subscribe()
        {
        }

        /// <summary>
        /// Creates a new instance of Subscribe
        /// </summary>
        /// <param name="body">the request message body</param>
        public Subscribe(SubscribeRequestType body)
            : base(body)
        {
        }

        /// <summary>
        /// Creates a new instance of Subscribe
        /// </summary>
        /// <param name="body">the request message body</param>
        /// <param name="responsePort">the response port for the request</param>
        public Subscribe(SubscribeRequestType body, PortSet<SubscribeResponseType, Fault> responsePort)
            : base(body, responsePort)
        {
        }
    }
    /// <summary>
    /// csproj402 replace operation
    /// </summary>
    public class Replace : Replace<csproj402State, PortSet<DefaultReplaceResponseType, Fault>>
    {
    }
}


