using System;
using System.Collections.Generic;
using System.ComponentModel;
using Microsoft.Ccr.Core;
using Microsoft.Dss.Core.Attributes;
using Microsoft.Dss.ServiceModel.Dssp;
using Microsoft.Dss.ServiceModel.DsspServiceBase;
using W3C.Soap;
using submgr = Microsoft.Dss.Services.SubscriptionManager;

namespace Robotics.csproj403
{
    [Contract(Contract.Identifier)]
    [DisplayName("csproj403")]
    [Description("csproj403 service (no description provided)")]
    class csproj403Service : DsspServiceBase
    {
        /// <summary>
        /// Service state
        /// </summary>
        [ServiceState]
        csproj403State _state = new csproj403State();

        /// <summary>
        /// Main service port
        /// </summary>
        [ServicePort("/csproj403", AllowMultipleInstances = true)]
        csproj403Operations _mainPort = new csproj403Operations();

        [SubscriptionManagerPartner]
        submgr.SubscriptionManagerPort _submgrPort = new submgr.SubscriptionManagerPort();

        /// <summary>
        /// Service constructor
        /// </summary>
        public csproj403Service(DsspServiceCreationPort creationPort)
            : base(creationPort)
        {
            _state.Name = "okawa";
            _state.Male = true;
            _state.Height = 168.5f;
            _state.Weight = 60.23f;
            _state.Index = 1.0f;
        }

        /// <summary>
        /// Service start
        /// </summary>
        protected override void Start()
        {

            // 
            // Add service specific initialization here
            // 

            base.Start();
        }

        /// <summary>
        /// Handles Subscribe messages
        /// </summary>
        /// <param name="subscribe">the subscribe request</param>
        [ServiceHandler]
        public void SubscribeHandler(Subscribe subscribe)
        {
            SubscribeHelper(_submgrPort, subscribe.Body, subscribe.ResponsePort);
        }
        /// <summary>
        /// Handles Replace messages
        /// </summary>
        /// <param name="replace"></param>
        [ServiceHandler(ServiceHandlerBehavior.Exclusive)]
        public virtual IEnumerator<ITask> ReplaceHandler(Replace replace)
        {
            _state = replace.Body;
            replace.ResponsePort.Post(DefaultReplaceResponseType.Instance);
            yield break;
        }
        /// <summary>
        /// Handles Calculate messages
        /// </summary>
        /// <param name="replace"></param>
        [ServiceHandler(ServiceHandlerBehavior.Exclusive)]
        public virtual IEnumerator<ITask> CalculateHandler(Calculate calculate)
        {
            _state.Index = _state.Height / _state.Weight;
            calculate.ResponsePort.Post(DefaultUpdateResponseType.Instance);
            yield break;
        }
    }
}


