using System;
using System.Collections.Generic;
using System.ComponentModel;
using Microsoft.Ccr.Core;
using Microsoft.Dss.Core.Attributes;
using Microsoft.Dss.ServiceModel.Dssp;
using Microsoft.Dss.ServiceModel.DsspServiceBase;
using W3C.Soap;

namespace Robotics.csproj403
{
    /// <summary>
    /// csproj403 contract class
    /// </summary>
    public sealed class Contract
    {
        /// <summary>
        /// DSS contract identifer for csproj403
        /// </summary>
        [DataMember]
        public const string Identifier = "http://schemas.tempuri.org/2011/03/csproj403.html";
    }

    /// <summary>
    /// csproj403 state
    /// </summary>
    [DataContract]
    public class csproj403State
    {
        [DataMember]
        public string Name { get; set; }
        [DataMember]
        public bool Male { get; set; }
        [DataMember]
        public float Height { get; set; }
        [DataMember]
        public float Weight { get; set; }
        [DataMember]
        public float Index { get; set; }
    }

    /// <summary>
    /// csproj403 main operations port
    /// </summary>
    [ServicePort]
    public class csproj403Operations : PortSet<DsspDefaultLookup, DsspDefaultDrop, Get, Subscribe, Replace, Calculate>
    {
    }

    /// <summary>
    /// csproj403 get operation
    /// </summary>
    public class Get : Get<GetRequestType, PortSet<csproj403State, Fault>>
    {
        /// <summary>
        /// Creates a new instance of Get
        /// </summary>
        public Get()
        {
        }

        /// <summary>
        /// Creates a new instance of Get
        /// </summary>
        /// <param name="body">the request message body</param>
        public Get(GetRequestType body)
            : base(body)
        {
        }

        /// <summary>
        /// Creates a new instance of Get
        /// </summary>
        /// <param name="body">the request message body</param>
        /// <param name="responsePort">the response port for the request</param>
        public Get(GetRequestType body, PortSet<csproj403State, Fault> responsePort)
            : base(body, responsePort)
        {
        }
    }

    /// <summary>
    /// csproj403 subscribe operation
    /// </summary>
    public class Subscribe : Subscribe<SubscribeRequestType, PortSet<SubscribeResponseType, Fault>>
    {
        /// <summary>
        /// Creates a new instance of Subscribe
        /// </summary>
        public Subscribe()
        {
        }

        /// <summary>
        /// Creates a new instance of Subscribe
        /// </summary>
        /// <param name="body">the request message body</param>
        public Subscribe(SubscribeRequestType body)
            : base(body)
        {
        }

        /// <summary>
        /// Creates a new instance of Subscribe
        /// </summary>
        /// <param name="body">the request message body</param>
        /// <param name="responsePort">the response port for the request</param>
        public Subscribe(SubscribeRequestType body, PortSet<SubscribeResponseType, Fault> responsePort)
            : base(body, responsePort)
        {
        }
    }
    /// <summary>
    /// csproj403 replace operation
    /// </summary>
    public class Replace : Replace<csproj403State, PortSet<DefaultReplaceResponseType, Fault>>
    {
    }
    /// <summary>
    /// csproj403 calculate operation
    /// </summary>
    public class Calculate : Update<CalculateBody, PortSet<DefaultUpdateResponseType, Fault>>
    {
        public Calculate():base(new CalculateBody())
        {
        }
    }
    [DataContract]
    public class CalculateBody
    {
    }
}


