using System;
using System.Collections.Generic;
using System.ComponentModel;
using Microsoft.Ccr.Core;
using Microsoft.Dss.Core.Attributes;
using Microsoft.Dss.ServiceModel.Dssp;
using Microsoft.Dss.ServiceModel.DsspServiceBase;
using W3C.Soap;

namespace Robotics.csproj404
{
    /// <summary>
    /// csproj404 contract class
    /// </summary>
    public sealed class Contract
    {
        /// <summary>
        /// DSS contract identifer for csproj404
        /// </summary>
        [DataMember]
        public const string Identifier = "http://schemas.tempuri.org/2011/03/csproj404.html";
    }

    /// <summary>
    /// csproj404 state
    /// </summary>
    [DataContract]
    public class csproj404State
    {
        [DataMember]
        public string Name { get; set; }
        [DataMember]
        public bool Male { get; set; }
        [DataMember]
        public float Height { get; set; }
        [DataMember]
        public float Weight { get; set; }
        [DataMember]
        public float Index { get; set; }
    }

    /// <summary>
    /// csproj404 main operations port
    /// </summary>
    [ServicePort]
    public class csproj404Operations : PortSet<DsspDefaultLookup, DsspDefaultDrop, Get, Subscribe, Replace, Calculate>
    {
    }

    /// <summary>
    /// csproj404 get operation
    /// </summary>
    public class Get : Get<GetRequestType, PortSet<csproj404State, Fault>>
    {
        /// <summary>
        /// Creates a new instance of Get
        /// </summary>
        public Get()
        {
        }

        /// <summary>
        /// Creates a new instance of Get
        /// </summary>
        /// <param name="body">the request message body</param>
        public Get(GetRequestType body)
            : base(body)
        {
        }

        /// <summary>
        /// Creates a new instance of Get
        /// </summary>
        /// <param name="body">the request message body</param>
        /// <param name="responsePort">the response port for the request</param>
        public Get(GetRequestType body, PortSet<csproj404State, Fault> responsePort)
            : base(body, responsePort)
        {
        }
    }

    /// <summary>
    /// csproj404 subscribe operation
    /// </summary>
    public class Subscribe : Subscribe<SubscribeRequestType, PortSet<SubscribeResponseType, Fault>>
    {
        /// <summary>
        /// Creates a new instance of Subscribe
        /// </summary>
        public Subscribe()
        {
        }

        /// <summary>
        /// Creates a new instance of Subscribe
        /// </summary>
        /// <param name="body">the request message body</param>
        public Subscribe(SubscribeRequestType body)
            : base(body)
        {
        }

        /// <summary>
        /// Creates a new instance of Subscribe
        /// </summary>
        /// <param name="body">the request message body</param>
        /// <param name="responsePort">the response port for the request</param>
        public Subscribe(SubscribeRequestType body, PortSet<SubscribeResponseType, Fault> responsePort)
            : base(body, responsePort)
        {
        }
    }
    /// <summary>
    /// csproj404 replace operation
    /// </summary>
    public class Replace : Replace<csproj404State, PortSet<DefaultReplaceResponseType, Fault>>
    {
    }
    /// <summary>
    /// csproj404 calculate operation
    /// </summary>
    public class Calculate : Update<CalculateBody, PortSet<DefaultUpdateResponseType, Fault>>
    {
        public Calculate()
            : base(new CalculateBody())
        {
        }
        public Calculate(float coef)
            : base(new CalculateBody(coef))
        {
        }
    }
    [DataContract]
    public class CalculateBody
    {
        public CalculateBody()
        {
        }
        public CalculateBody(float coef)
        {
            delta = coef;
        }
        [DataMember]
        public float delta { get; set; }
    }
}


