﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Net.Sockets;
using System.Net;

namespace Robotics.csprojUDP2
{
    class receiveUDP
    {
        public const int BUFSIZE = 32;
        public IPEndPoint endpoint;
        public UdpClient client;
        public csprojUDP2Operations mainport;
        // コンストラクタ
        public receiveUDP(IPEndPoint remoteIPEndPoint, UdpClient client, csprojUDP2Operations mainport)
        {
            endpoint = remoteIPEndPoint;
            this.client = client;
            this.mainport = mainport;
        }
        // 受信メソッド
        public void receiveMsg()
        {
            byte[] rcvBuffer = new byte[BUFSIZE];
            int bytesRcvd;
            // メッセージループ
            while (true)
            {
                rcvBuffer = client.Receive(ref endpoint);
                bytesRcvd = rcvBuffer.Length;

                if (bytesRcvd > 0)
                {
                    string str = Encoding.ASCII.GetString(rcvBuffer, 0, bytesRcvd - 1);
                    mainport.Post(new SetCommand(str));
                    // 終了コードのチェック
                    if (str == "end") break;
                }
                else
                {
                    mainport.Post(new SetCommand("ERROR"));
                }
            }
        }
    }
}
