//
//  projUDPViewController.m
//  projUDP
//
//  Created by コウガク シャ on 11/03/18.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "projUDPViewController.h"

@implementation projUDPViewController


@synthesize textfield, textfield2;

//
// 初期化
//

// ソケット生成
- (int) createSocket{
	// ソケット生成
	sock = -1;
	sock = socket(AF_INET, SOCK_DGRAM, 0);
	if (sock < 0){
		NSLog(@"Fail: createSend");
		return -1;
	}
	NSLog(@"Success: createSend");
	
	// サーバーアドレス
	serverAddr.sin_addr.s_addr = inet_addr(serverIP);
	serverAddr.sin_port = htons(atoi(serverPort));
	serverAddr.sin_family = AF_INET;
	
	// 受信スレッドスタート
	[NSThread detachNewThreadSelector:@selector(recieveRobot) toTarget:self withObject:nil];
	return 0;
}

//
// 送信
//

// メッセージ転送
- (int) sendString:(char[])msg{
	int l = strlen(msg);
	int rt = sendto(sock, msg, l + 1, 0, &serverAddr, sizeof(serverAddr));
	if (rt != l + 1) {
		NSLog(@"Fail: sendString");
		return -4;
	}
	NSLog(@"Success: sendString");
	return 0;
}

// テキストフィールドの文字列の送信
- (void) send:(id)sender{
	char szBuf[buflength] = "Hello World!";
	[textfield.text getCString:szBuf maxLength:buflength];
	[self sendString:szBuf];
}

// サーバーシャットダウン
- (void) closeServer:(id)sender{
	[self sendString:shutdownCode];
	textfield.text = @"sent Server Shutdown Code";
}


//
// 受信
//

// 受信スレッド
- (void) recieveRobot{
	struct sockaddr_in from;
	int fromlen = (int)sizeof(from);
	char szBuf[buflength];
	memset(szBuf, 0, sizeof(szBuf));
	while (1){
		int rt = recvfrom(sock, szBuf, (int)sizeof(szBuf) - 1, 0, &from, &fromlen);
		NSLog(@"%d,%s",rt,szBuf);
		NSLog(@"Recieved %d", rt - 1);
		NSLog(@"%s", inet_ntoa(from.sin_addr));
		
		NSLog(@"%s",szBuf);
		NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
		NSData *msg = [NSData dataWithBytes:szBuf length:sizeof(szBuf)];
		NSData *num = [NSData dataWithBytes:&rt length:sizeof(rt)];
		NSArray *argments = [NSArray arrayWithObjects:msg, num, nil];
		[self performSelectorOnMainThread:@selector(disp:) withObject:argments waitUntilDone:YES];
		[pool release];
	}
}

// メインスレッド上の処理
- (void) disp:(NSArray *)argments{
	NSLog(@"disp");
	NSData *msg = [argments objectAtIndex:0];
	NSData *num = [argments objectAtIndex:1];
	NSString *str1 = [[[NSString alloc] initWithFormat:@"RECEIVED %s", [msg bytes]] autorelease];
	textfield2.text = str1;
}

// printHello
- (void) printHello:(id)sender{
	ctr++;
	NSString *str = [[[NSString alloc] initWithFormat:@"%d: Hello World!", ctr] autorelease];
	textfield.text = str;
}

//
// 終了処理
//

// 送信ソケット削除
- (int) closeSocket{
	int rt = close(sock);
	if (rt == 0) {
		NSLog(@"Success: closeSend");
		return 0;
	}
	NSLog(@"Fail: closeSend");
	return -5;
}


/*
 // The designated initializer. Override to perform setup that is required before the view is loaded.
 - (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
 if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
 // Custom initialization
 }
 return self;
 }
 */

/*
 // Implement loadView to create a view hierarchy programmatically, without using a nib.
 - (void)loadView {
 }
 */



// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	ctr = 0;
    [super viewDidLoad];
	[self createSocket];
}



/*
 // Override to allow orientations other than the default portrait orientation.
 - (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
 // Return YES for supported orientations
 return (interfaceOrientation == UIInterfaceOrientationPortrait);
 }
 */

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
	[self closeSocket];
}

@end
