//
//  projTCPViewController.m
//  projTCP
//
//  Created by コウガク シャ on 11/03/25.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "projTCPViewController.h"

@implementation projTCPViewController



@synthesize textfield, textfield2;
//
// 初期化
//
// ソケット生成
- (void) createSocket{
	s = -1;
	s = socket(AF_INET, SOCK_STREAM, 0);
	if (s < 0){
		textfield.text = @"Fail: createSocket";
	}
	else {
		textfield.text = @"CREATED";
	}	
}	

// サーバーへ接続
- (void) connectServer:(id)sender{
	memset(&sockaddrin, 0, sizeof(sockaddrin));
	// ネットワークアドレス
	sockaddrin.sin_addr.s_addr = inet_addr(robotIP);
	sockaddrin.sin_port = htons(atoi(robotPort));
	sockaddrin.sin_family = AF_INET;
	
	if(connect(s, (const struct sockaddr *)&sockaddrin, sizeof(sockaddrin)) != 0){
		textfield.text = @"connect fail";
		return;
	}else{
		textfield.text = @"connected";
	}
	
	// スレッドスタート
	[NSThread detachNewThreadSelector:@selector(recieveRobot) toTarget:self withObject:nil];
}

//
// 受信
//
// 受信スレッド
- (void) recieveRobot{
	char rcBuf[bufferSize];
	while (flag){
		memset(rcBuf, 0, sizeof(rcBuf));
		int rt = recv(s, rcBuf, (int)sizeof(rcBuf) - 1, 0);
		NSLog(@"Recieved %d %s", rt, rcBuf);
		if (rt != strlen(rcBuf)) {
			textfield.text = @"Fail: recieve";
			return;
		}
		// メインスレッド上での処理を起動
		NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
		NSData *msg = [NSData dataWithBytes:rcBuf length:strlen(rcBuf)];
		NSData *num = [NSData dataWithBytes:&rt length:sizeof(int)];
		NSArray *argments = [NSArray arrayWithObjects:msg, num, nil];
		[self performSelectorOnMainThread:@selector(disp:) withObject:argments waitUntilDone:YES];
		[pool release];
	}
}

// メインスレッド上の処理
- (void) disp:(NSArray *)argments{
	NSLog(@"disp");
	NSData *msg = [argments objectAtIndex:0];
	NSData *num = [argments objectAtIndex:1];
	NSString *str1 = [[[NSString alloc] initWithFormat:@"RECEIVED %s", [msg bytes]] autorelease];
	textfield2.text = str1;
}
// 文字列の送信
- (void) sendMsg:(id)sender{
	[textfield.text getCString:szBuf maxLength:bufferSize];
	int l = strlen(szBuf);
	int rt = send(s, szBuf, l + 1, 0);
	if (rt != l + 1) {
		textfield.text = @"Fail: send";
	}
	else {
		textfield.text = @"Success: send";
	}
}

// サーバーシャットダウン
- (void) shutdownServer:(id)sender{
	char shutdownCode[4] = "end";
	int l = strlen(shutdownCode);
	int rt = send(s, shutdownCode, l + 1, 0);
	if (rt != l + 1) {
		textfield.text = @"Fail: Shutdown Server";
	}
	else {
		textfield.text = @"Success: Shutdown Server";
	}
	flag = false;
}

//
// 終了処理
//

// ソケット削除
- (void) closeSocket{
	int rt = close(s);
	if (rt == 0) {
		textfield.text = @"CLOSED";
	}
	else {
		textfield.text = @"Fail: closeSocket";
	}
}

/*
 // The designated initializer. Override to perform setup that is required before the view is loaded.
 - (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
 if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
 // Custom initialization
 }
 return self;
 }
 */

/*
 // Implement loadView to create a view hierarchy programmatically, without using a nib.
 - (void)loadView {
 }
 */



// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	[super viewDidLoad];
	[self createSocket];
	flag = true;
}



/*
 // Override to allow orientations other than the default portrait orientation.
 - (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
 // Return YES for supported orientations
 return (interfaceOrientation == UIInterfaceOrientationPortrait);
 }
 */

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[self closeSocket];
    [super dealloc];
}

@end
