﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Net.Sockets;
using System.Net;

namespace Robotics.UDP701
{
    class receiveUDP
    {
        public const int BUFSIZE = 32;
        private const char errorCode = 'e';
        public IPEndPoint endpoint;
        public UdpClient client;
        public UDP701Operations mainport;
        // コンストラクタ
        public receiveUDP(IPEndPoint remoteIPEndPoint, UdpClient client, UDP701Operations mainport)
        {
            endpoint = remoteIPEndPoint;
            this.client = client;
            this.mainport = mainport;
        }
        // 受信メソッド
        public void receiveMsg()
        {
            byte[] rcvBuffer = new byte[BUFSIZE];
            int bytesRcvd;
            // メッセージループ
            while (true)
            {
                rcvBuffer = client.Receive(ref endpoint);
                bytesRcvd = rcvBuffer.Length;

                if (bytesRcvd > 0)
                {
                    mainport.Post(new SetCommand(rcvBuffer));
                }
                else
                {
                    rcvBuffer[0] = (byte)errorCode;
                    rcvBuffer[1] = 0x00;
                    mainport.Post(new SetCommand(rcvBuffer));
                }
            }
        }
    }
}
