//
//  iUDP902ViewController.m
//  iUDP902
//
//  Created by コウガク シャ on 11/04/25.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "iUDP902ViewController.h"

@implementation iUDP902ViewController


@synthesize textfield;

//
// 初期化
//

// UDPソケット生成
- (int) createSocket{
	// ソケット生成
	sock = -1;
	sock = socket(AF_INET, SOCK_DGRAM, 0);
	if (sock < 0){
		NSLog(@"Fail: createSend");
		return -1;
	}
	NSLog(@"Success: createSend");
	
	// サーバーアドレス
	serverAddr.sin_addr.s_addr = inet_addr(serverIP);
	serverAddr.sin_port = htons(atoi(serverPort));
	serverAddr.sin_family = AF_INET;
	
	// 受信スレッドスタート
	[NSThread detachNewThreadSelector:@selector(recieveRobot) toTarget:self withObject:nil];
	textfield.text = @"Thread started";
	return 0;
}

// サーバーへ接続
- (void) connect:(id)sender{
	Packet pkt;
	pkt.cmd = openCode;
	pkt.Distance = CACurrentMediaTime() - startTime;
	pkt.Power = 0;
	[self sendString:pkt];
	textfield.text = @"Connected";
}	

//
// メッセージ送信
//

// 文字列の転送
- (int) sendString:(Packet)pkt{
	memset(szBuf, 0, buflength);
	int n = sprintf(szBuf, "%c%10.2f%10.2f", pkt.cmd, pkt.Distance, pkt.Power);
	int rt = sendto(sock, szBuf, n, 0, &serverAddr, sizeof(serverAddr));
	if (rt != n + 1) {
		NSLog(@"Fail: sendString");
		return -4;
	}
	NSLog(@"Success: sendString");
	return 0;
}

// ロボット前進
- (void) forward:(id)sender{
	Packet pkt;
	pkt.cmd = packetCode;
	pkt.Distance = 1.0;
	pkt.Power = 0.5f;
	[self sendString:pkt];
	textfield.text = @"Forward";
}

// ロボット後退
- (void) backward:(id)sender{
	Packet pkt;
	pkt.cmd = packetCode;
	pkt.Distance = -1.0;
	pkt.Power = 0.5f;
	[self sendString:pkt];
	textfield.text = @"Backward";
}

// ロボット右回転
- (void) right:(id)sender{ 
	Packet pkt;
	pkt.cmd = rotateCode;
	pkt.Distance = -45.0f;
	pkt.Power = 0.5f;
	[self sendString:pkt];
	textfield.text = @"Rotate Right";
}

// ロボット左回転
- (void) left:(id)sender{
	Packet pkt;
	pkt.cmd = rotateCode;
	pkt.Distance = 45.0f;
	pkt.Power = 0.5f;
	[self sendString:pkt];
	textfield.text = @"Rotate Left";
}

// サーバーシャットダウン
- (void) close:(id)sender{
	Packet pkt;
	pkt.cmd = shutdownCode;
	pkt.Distance = CACurrentMediaTime() - startTime;
	pkt.Power = -1;
	[self sendString:pkt];
	textfield.text = @"Line closed";
}

//
// 受信
//

// 受信スレッド
- (void) recieveRobot{
	struct sockaddr_in from;
	int fromlen = (int)sizeof(from);
	char szBuf[buflength];
	memset(szBuf, 0, sizeof(szBuf));
	while (1){
		int rt = recvfrom(sock, szBuf, (int)sizeof(szBuf) - 1, 0, &from, &fromlen);
		NSLog(@"%d,%s",rt,szBuf);
		NSLog(@"Recieved %d", rt - 1);
		NSLog(@"%s", inet_ntoa(from.sin_addr));
		
		NSLog(@"%s",szBuf);
		NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
		NSData *msg = [NSData dataWithBytes:szBuf length:sizeof(szBuf)];
		NSData *num = [NSData dataWithBytes:&rt length:sizeof(rt)];
		NSArray *argments = [NSArray arrayWithObjects:msg, num, nil];
		[self performSelectorOnMainThread:@selector(disp:) withObject:argments waitUntilDone:YES];
		[pool release];
	}
}

// メインスレッド上の処理
- (void) disp:(NSArray *)argments{
	NSLog(@"disp");
	NSData *msg = [argments objectAtIndex:0];
	NSData *num = [argments objectAtIndex:1];
	
	NSString *str = [[[NSString alloc] initWithFormat:@"%s", [msg bytes]] autorelease];
	
	int8_t *s1 = [msg bytes];
	
	NSString *str0 = [NSString stringWithFormat:@"%c", (char)s1[0]];
	
	char v1[10], v2[10];
	for (int k = 0; k < 10; k++) {
		v1[k] = (char)s1[k+1];
		v2[k] = (char)s1[k + 11];
	}
	float f1 = atof(v1);
	float f2 = atof(v2);
	NSString *str1 = [NSString stringWithFormat:@"%10.2f", f1];
	NSString *str2 = [NSString stringWithFormat:@"%10.2f", f2];
	textfield.text = [NSString stringWithFormat:@"Completed: %c %f %f",(char)s1[0], f1, f2];
}

//
// 終了処理
//

// 送信ソケット削除
- (int) closeSocket{
	int rt = close(sock);
	if (rt == 0) {
		NSLog(@"Success: closeSend");
		return 0;
	}
	NSLog(@"Fail: closeSend");
	return -5;
}


/*
 // The designated initializer. Override to perform setup that is required before the view is loaded.
 - (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
 if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
 // Custom initialization
 }
 return self;
 }
 */

/*
 // Implement loadView to create a view hierarchy programmatically, without using a nib.
 - (void)loadView {
 }
 */



// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	startTime = CACurrentMediaTime();
    [super viewDidLoad];
	[self createSocket];
}



/*
 // Override to allow orientations other than the default portrait orientation.
 - (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
 // Return YES for supported orientations
 return (interfaceOrientation == UIInterfaceOrientationPortrait);
 }
 */

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
	[self closeSocket];
}

@end
