//
//  iTCP1002ViewController.m
//  iTCP1002
//
//  Created by コウガク シャ on 11/04/29.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "iTCP1002ViewController.h"

@implementation iTCP1002ViewController


@synthesize textfield, textfieldR, textfieldL, textfieldA, textfieldB;

//
// 初期化
//
// TCPソケット生成
- (void) createSocket{
	s = -1;
	s = socket(AF_INET, SOCK_STREAM, 0);
	if (s < 0){
		textfield.text = @"Fail: createSocket";
		return -1;
	}
	else {
		textfield.text = @"CREATED";
		return 0;
	}
}	

// サーバーへ接続
- (void) connect:(id)sender{
	memset(&sockaddrin, 0, sizeof(sockaddrin));
	// ネットワークアドレス
	sockaddrin.sin_addr.s_addr = inet_addr(robotIP);
	sockaddrin.sin_port = htons(atoi(robotPort));
	sockaddrin.sin_family = AF_INET;
	
	if(connect(s, (const struct sockaddr *)&sockaddrin, sizeof(sockaddrin)) != 0){
		textfield.text = @"connect fail";
		return;
	}else{
		textfield.text = @"connected";
	}
	
	// スレッドスタート
	[NSThread detachNewThreadSelector:@selector(recieveRobot) toTarget:self withObject:nil];
}

//
// メッセージ送信
//

// メッセージ転送
- (int) sendString:(Packet)pkt{
	Packet p = pkt;
	pkt.Distance = rightPower + rightAngle;
	pkt.Power = leftPower + leftAngle;
	NSString *r = [[NSString alloc] initWithFormat:@"%5.1f",rightPower];
	textfieldR.text = r;
	NSString *l = [[NSString alloc] initWithFormat:@"%5.1f",leftPower];
	textfieldL.text = l;
	NSString *a = [[NSString alloc] initWithFormat:@"%5.1f",rightAngle];
	textfieldA.text = a;
	NSString *b = [[NSString alloc] initWithFormat:@"%5.1f",leftAngle];
	textfieldB.text = b;
	memset(szBuf, 0, buflength);
	int n = sprintf(szBuf, "%c%10.2f%10.2f", pkt.cmd, pkt.Distance, pkt.Power);
	int rt = send(s, szBuf, n, 0);
	if (rt != n ) {
		NSLog(@"Fail: sendString");
		return -4;
	}
	NSLog(@"Success: sendString");
	return 0;
}

// ロボット前進
- (void) forward:(id)sender{
	rightPower += deltaPower;
	leftPower += deltaPower;
	Packet pkt;
	pkt.cmd = packetCode;
	[self sendString:pkt];
	textfield.text = @"Forward";
}

// ロボット後退
- (void) backward:(id)sender{
	rightPower -= deltaPower;
	leftPower -= deltaPower;
	Packet pkt;
	pkt.cmd = packetCode;
	[self sendString:pkt];
	textfield.text = @"Backward";
}

// ロボット停止
- (void) stop:(id)sender{
	rightPower = 0.0f;
	leftPower = 0.0f;
	rightAngle = 0.0f;
	leftAngle = 0.0f;
	Packet pkt;
	pkt.cmd = packetCode;
	[self sendString:pkt];
	textfield.text = @"Backward";
}

// ハンドル右回転
- (void) right:(id)sender{ 
	rightAngle -= deltaAngle;
	leftAngle += deltaAngle;
	Packet pkt;
	pkt.cmd = packetCode;
	[self sendString:pkt];
	textfield.text = @"Rotate Right";
}

// ハンドル左回転
- (void) left:(id)sender{
	rightAngle += deltaAngle;
	leftAngle -= deltaAngle;
	Packet pkt;
	pkt.cmd = packetCode;
	[self sendString:pkt];
	textfield.text = @"Rotate Left";
}

// ハンドル
- (void) center:(id)sender{
	rightPower = 0.5 * (rightPower + leftPower);
	leftPower = rightPower;
	rightAngle = 0.0;
	leftAngle = 0.0;
	Packet pkt;
	pkt.cmd = packetCode;
	[self sendString:pkt];
	textfield.text = @"Rotate Left";
}

// サーバーシャットダウン
- (void) close:(id)sender{
	Packet pkt;
	pkt.cmd = shutdownCode;
	[self sendString:pkt];
	textfield.text = @"sent Server Shutdown Code";
	flag = false;
}

//
// 受信
//
// 受信スレッド
- (void) recieveRobot{
	while (flag){
		memset(szBuf, 0, sizeof(szBuf));
		int rt = recv(s, szBuf, (int)sizeof(szBuf) - 1, 0);
		NSLog(@"Recieved %d %s", rt, szBuf);
		if (rt != strlen(szBuf)) {
			textfield.text = @"Fail: recieve";
			return;
		}
		// メインスレッド上での処理を起動
		NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
		NSData *msg = [NSData dataWithBytes:szBuf length:strlen(szBuf)];
		NSData *num = [NSData dataWithBytes:&rt length:sizeof(int)];
		NSArray *argments = [NSArray arrayWithObjects:msg, num, nil];
		[self performSelectorOnMainThread:@selector(disp:) withObject:argments waitUntilDone:YES];
		[pool release];
	}
}

// メインスレッド上の処理
- (void) disp:(NSArray *)argments{
	NSLog(@"disp");
	NSData *msg = [argments objectAtIndex:0];
	NSData *num = [argments objectAtIndex:1];
	NSString *str = [[[NSString alloc] initWithFormat:@"RECEIVED %s", [msg bytes]] autorelease];
	textfield.text = str;
	
	int8_t *s1 = [msg bytes];
	
	NSString *str0 = [NSString stringWithFormat:@"%c", (char)s1[0]];
	//	textfieldA.text = str0;
	
	char v1[10], v2[10];
	for (int k = 0; k < 10; k++) {
		v1[k] = (char)s1[k+1];
		v2[k] = (char)s1[k + 11];
	}
	float f1 = atof(v1);
	float f2 = atof(v2);
	NSString *str1 = [NSString stringWithFormat:@"%10.2f", f1];
	NSString *str2 = [NSString stringWithFormat:@"%10.2f", f2];
}

//
// 終了処理
//

// ソケット削除
- (int) closeSocket{
	int rt = close(s);
	if (rt == 0) {
		textfield.text = @"CLOSED";
		return 0;
	}
	else {
		textfield.text = @"Fail: closeSocket";
		return -5;
	}
}

/*
 // The designated initializer. Override to perform setup that is required before the view is loaded.
 - (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
 if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
 // Custom initialization
 }
 return self;
 }
 */

/*
 // Implement loadView to create a view hierarchy programmatically, without using a nib.
 - (void)loadView {
 }
 */



// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	[super viewDidLoad];
	startTime = CACurrentMediaTime();
	[self createSocket];
	flag = true;
	rightPower = 0.0;
	leftPower = 0.0;
	deltaPower = 0.4f;
	rightAngle = 0.0;
	leftAngle = 0.0;
	deltaAngle = 0.05f;
}



/*
 // Override to allow orientations other than the default portrait orientation.
 - (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
 // Return YES for supported orientations
 return (interfaceOrientation == UIInterfaceOrientationPortrait);
 }
 */

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[self closeSocket];
    [super dealloc];
}

@end
